jQuery(document).ready(function($)
{

	function initFancyBox()
	{
		if(jQuery.fancybox)
		{
			$('.instagram-image a[rel=instagram-images],.instapress-shortcode a[rel=instagram-sc-images]').fancybox();
		}
	}
	
	function initHighslide()
	{
		$('.instapress-highslide').click(function()
		{
			
			if(typeof(hs) !== 'undefined')
				return hs.expand(this);
			
			alert("You need a Highslide Plugin for WordPress!");
		});
	}
	
	function showPage(page)
	{
		$('.next-page-instapress').attr('rel', page*1+1);
		if(page > 1)
		{
			$('.prev-page-instapress').attr('rel', page*1-1).show();
		}
		else
		{
			$('.prev-page-instapress').hide();
		}
		$('.instapress-shortcode').hide();
		$('#instapress-shortcode-page-' + page).show();
	}
	
	function loading(hide)
	{
		if(!hide)
		{
			if($('#instapress-gallery-loading').length == 0)
				$('body').append('<div id="instapress-gallery-loading" />');
			var gallery = $('.instapress-shortcode-page:visible');
			var offset = gallery.offset();
			var w = gallery.outerWidth() / 2;
			var h = gallery.outerHeight() / 2;
			var t = offset.top + (h/2);
			var l = offset.left + (w/2);
			
			$('#instapress-gallery-loading').css({ top : t, left: l, width : w, height : h}).show();
		}
		else
		{
			$('#instapress-gallery-loading').hide();
		}
	}
	
	$('.prev-page-instapress').live('click', function()
	{
		var page = $(this).attr('rel');
		showPage(page);
		
		return false;
	});
	
	$('.next-page-instapress').live('click', function()
	{
		var page = $(this).attr('rel');
		instapressConfig.paging = page;
		var maxId = $('#instapress-next-max-id-' + page).val();
		
		if(!maxId || maxId.length == 0)
			page = 1;
		
		if($('#instapress-shortcode-page-' + page).length)
		{
			showPage(page);
			return false;
		}
		
		loading();
		$.post($(this).attr('href') + "/wp-admin/admin-ajax.php", 
		{
		    action : "instapress_paging",
		    config : instapressConfig,
		    nextMaxId : maxId 
		}, function(response)
		{
			$('.instapress-gallery').append(response);
			showPage(page);
			initFancyBox();
			loading(true);
		});   
		
		return false;
	});
	
	initFancyBox();
	
	initHighslide();
	
});